mod traits;

use serde::{Deserialize, Serialize};
use uuid::Uuid;

pub use self::traits::*;

#[derive(Clone, Debug, Deserialize, Serialize)]
#[serde(tag = "op", content = "d", rename_all = "snake_case")]
pub enum ClientboundPacket {
    // Authentication
    HandshakeRequest(HandshakeRequest),
}

#[derive(Clone, Debug, Deserialize, Serialize)]
#[serde(tag = "op", content = "d", rename_all = "snake_case")]
pub enum ServerboundPacket {
    // Authentication
    HandshakeResponse(HandshakeResponse),
}

#[derive(Clone, Debug, Deserialize, Serialize)]
pub struct HandshakeRequest {
    pub join_id: Uuid,
}

#[derive(Clone, Debug, Deserialize, Serialize)]
pub struct HandshakeResponse {
    pub player_name: String,
}

#[derive(Clone, Debug, Deserialize, Serialize)]
pub struct PlayerJoin {
    pub player_name: String,
}
